class ABMain of FORM custom
   with (this)
      onSize = class::FORM_ONSIZE
      onOpen = class::ONOPEN
      open = class::OPEN
      scaleFontBold = false
      metric = 6	// Pixels
      height = 100
      left = 250
      top = 100
      width = 250
      text = "Application"
      autoCenter = true
      escExit = false
   endwith


   function form_onSize(nSizeType, nWidth, nHeight)
      // This code is needed to restore the main form when the
      // user has maximized a form.
      if nSizeType = 2 and type("this.appbase") == "O"
         try
            this.appbase.lockDeskTop()
            this.appbase.restoreForm(this.hwnd)
            if this.Hide = true
               // Need to reset the visible property of the main
               // form. When user maximizes a form, the main form
               // could get maximized and become visible.
               this.visible = false
            endif
         finally
            lockWindowUpdate(0)
         endtry

      endif
      return

   function open
      if type("this.appbase") == "O"
         this.appbase.lockDesktop()

         // do custom beforeOpen stuff
         if type("this.beforeOpen") == "FP"
            this.beforeOpen()
         endif
      endif
      return super::open()

   function onOpen
      if type("this.appbase") == "O"
         if this.Hide = true
            // If the main form is always hidden, then we need 
            // to set the visible property to false.
            this.visible = false
         else
            // If the main form is not hidden, then change its 
            // apperance so it does not look like a normal form
            local WAttrib
            WAttrib = new WAttrib(this)
            WAttrib.Border(False)
         endif
         lockWindowUpdate(0)
      endif
      return
endclass
//
CLASS WAttrib(formObj)
*----------- 
*- Name.....Window Attributes(WAttrib)
*- Author...David Wedwick (CIS: 73677, 2600)
*- Notes....Extracted portion needed for this form from WAttrib.cc
*----------- 
   PROTECT Setting

   if type("GetWindowLong") <> "FP"
      EXTERN CLONG GetWindowLong(CHANDLE, CINT);
      USER32 from "GetWindowLongA"
   endif
 
   if type("SetWindowLong") <> "FP"
      EXTERN CLONG SetWindowLong(CHANDLE, CINT, CLONG);
      USER32 from "SetWindowLongA"
   endif
   
   if type("SetWindowPos") <> "FP"
      EXTERN CLOGICAL SetWindowPos(CHANDLE, CHANDLE, CINT,;
      CINT, CINT, CINT, CINT) USER32
   endif
   
   // Save a reference to the form's handle
   this.formhWND = formObj.hWND
   
   // Retrieve the current STYLE settings for the form
   this.nStyle = GetWindowLong(this.formhWND, -16)
   
   FUNCTION Border(lNewValue)
   ***************
      *-- RETURN .t. if the Border flag is enabled on the form
      *-- or .f. if not.  If lNewValue is passed, try to change the 
      *-- setting based on the new value.  RETURN the value before any 
      *-- changes.
      *-- Check the position in bit 23
      RETURN this.Setting(23, pcount() == 1, lNewValue)

   FUNCTION Setting(nBitPos, lChange, lNew)
   ****************
      *-- RETURN the current setting in nBitPos of the form's STYLE 
      *-- setting. If lChange is .t., change the setting to reflect the 
      *-- value in lNew.
      LOCAL lSet, nMask

      lSet = bitset(this.nStyle, nBitPos)

      if lChange
         nMask = bitlshift(1, nBitPos)

         if lNew .and. .not. lSet
           *-- Set the flag
           this.nStyle = this.nStyle + nMask
         elseif .not. lNew .and. lSet
           *-- Remove the flag
           this.nStyle = this.nStyle - nMask
         endif

         *-- Change the setting
         SetWindowLong(this.formhWND, -16, this.nStyle)

         *-- Make the changes visible.  Provided by Romain Strieff.
         #define SWP_NOSIZE          1
         #define SWP_NOMOVE          2
         #define SWP_FRAMECHANGED   32
         SetWindowPos(this.formhWND, 0,0,0,0,0, SWP_FRAMECHANGED+;
                      SWP_NOMOVE+SWP_NOSIZE)

         *-- Retrieve the new setting (should be the same, but if not...)
         this.nStyle = GetWindowLong(this.formhWND, -16)
      endif
      RETURN lSet

endclass
