*- Application Base Start Program
*- Generated by 'Application Base Wizard'
*- Written by Todd Kreuter
*- Generated on 10/19/1999 08:31:40 AM

set procedure to program()

local MyApp
MyApp = new AppBase()
return

class AppBase
*************
   try
      this.LockDeskTop()
      _app.MyApp = this

      // System Query
      this.qSystem = new Query()
      this.qSystem.sql = "Select * from system.dbf"
      this.qSystem.active = true

      // Application Files Query
      this.qFiles = new QUERY()
      this.qFiles.sql = "select * from ABFiles.dbf"
      this.qFiles.requestLive = false
      this.qFiles.active = true
      this.qFiles.rowset.indexName = "ID"

      // ToolBars
      set procedure to toolbars.cc additive
      this.toolBars       = new ToolBarBase(this)
      this.toolBars.setLarge(true)
      this.toolBars.Flat = true
      this.toolBars.Tool0 = new FrameToolBar(this.toolBars)
      this.toolBars.Tool0.attach(_app.framewin)
      this.toolBars.Tool1 = new DataToolBar(this.toolBars)

      // Application Base Main Form
      set procedure to Main.wfm additive
      this.ABMain = new MainForm()
      this.ABMain.mdi = true
      this.ABMain.Hide = true
      this.ABMain.appBase = this
      this.CurrentForm = this.ABMain

      // Enviroment Settings
      _app.framewin.oldText = _app.framewin.text
      _app.framewin.text = "My Application"
      _app.speedBar = false
      _app.statusBar = false

      if ( "runtime" $ lower( version(0) ) )
         set development off
      endif

      // MDI Application
      shell(true, True)

      // Run Setup Program
      do Setup.prg with this

      this.ABMain.open()
   catch (exception e)
      LockWindowUpdate(0)
      msgBox(e.message + " Line: " + ltrim(str(e.lineNo)), "Startup Error", 16)
   finally
      LockWindowUpdate(0)
   endtry
   return


   function ProcessFile(cID)
   ********************
      try
         local f, cRefName, cCheckRef, i, formObj
         private cMacro

         // Find the file ID in the ABFiles Table
         f = this.qFiles.rowset.fields
         if not this.qFiles.rowset.findKey(cID)
           msgBox("The File ID " + cID + " was not Found in the ABFiles Table", "Process Failed", 16)
            return false
         endif

         // If file is to be run, run and return
         if f["Run"].value
            do (trim(f["Name"].value))
            return true
         endif

         // Get a Reference
         if f["MaxInst"].value # 1
            cCheckRef = "this." + cID
            if type(cCheckRef) # "A"
               // Create array if not exist
               cMacro = cCheckRef + " = new array(" + str(f["MaxInst"].value,1) + ")"
               &cMacro
            endif

            cRefName = cID + "[1]"
            i = 1
            // Loop through array until an empty reference is found
            do while i <= f["MaxInst"].value
               if type(cCheckRef + "[" + str(i,1) + "]") # "O"
                  cRefName = cID + "[" + str(i,1) + "]"
                  exit
               endif
               i += 1
            enddo
         else
            cRefName = cID
         endif

         if type("this." + cRefName) # "O"
            // Create new Instance
            set procedure to (trim(f["Name"].value)) additive
            cMacro = "this." + cRefName + " = new " + trim(f["Class"].value) + "()"
            &cMacro
            cMacro = "this." + cRefName
            formObj = &cMacro

            // Store form reference (as a string) to the form
            formObj.RefName = cRefName
            // Store appBase reference (as an object) to the form
            formObj.appBase = this

            // Attach ToolBars
            if f["Modal"].value # True

               if f["Tool1"].value
                 this.toolBars.Tool1.attach(formObj)
               endif

            endif

            // Open or ReadModal
            if f["Modal"].value
               this.lockWindow()
               formObj.mdi = false
               formObj.readModal()
            else

               this.lockWindow()
               formObj.visible = false
               formObj.MDI =true
               formObj.open()
               formObj.setfocus()
               formObj.visible = true
            endif

         else
            this.lockWindow()
            cMacro = "this." + cRefName
            formObj = &cMacro
            if formObj.windowState = 1
               this.restoreForm(formObj.hwnd)
            endif
            formObj.setFocus()
         endif

      catch(exception e)
         LockWindowUpdate(0)
         msgBox(e.message + " Line: " + ltrim(str(e.lineNo)), "Error", 16)
      finally
         lockWindowUpdate(0)
      endtry
      return

   function ZapForm (cRefName)
   ****************
      // Set focus to ABMain Form before destroying reference
      this.ABMain.setfocus()

      // Release form and null reference to the form
      private cRef, cMacro
      cRef = "this."  + cRefName
      if type(cRef) == "O"
         cMacro = cRef + ".release()"
         &cMacro
         cMacro = cRef + " = Null"
         &cMacro
      else
         msgBox("Check the Parameter Passed to the ZapForm Method: " + cRef, "Invalid Type", 16)
      endif
      return

   function Exit
   *************
      // Exit the Application / Destroy AppBase References
      close forms

      // Detatch toolBar attached to frameWin
      this.toolBars.Tool0.detach(_app.framewin)

      this.toolBars.Tool0 = null
      this.toolBars.Tool1 = null
      this.ABMain.close()
      this.ABMain.release()
      this.ABMain = null
      this.currentForm = null

      this.qSystem.active = false
      this.qSystem = null

      this.qFiles.active = false
      this.qFiles = null

      // Close procedure(s)
      close procedure toolbars.cc
      close procedure Main.wfm

      if ( "runtime" $ lower( version(0) ) )
         quit
      endif
      // Reset Development Enviroment
      with ( _app )
         framewin.text := _app.framewin.oldText
         speedBar      := true
         statusBar     := true
      endwith
      shell(true, true)
      return

   function LockWindow
   *******************
      if type("LockWindowUpdate") # "FP"
         extern cLogical LockWindowUpdate( cHandle ) user32
      endif
      if type("GetActiveWindow") # "FP"
         extern cHandle GetActiveWindow( cVoid ) user32
      endif
      return LockWindowUpdate( GetActiveWindow() )

   function LockDeskTop
   ********************
      if type("LockWindowUpdate") # "FP"
         extern cLogical LockWindowUpdate( cHandle ) user32
      endif
      if type("GetDesktopWindow") # "FP"
         extern cHandle GetDesktopWindow( cVoid ) user32
      endif
      return LockWindowUpdate( GetDesktopWindow() )

   function RestoreForm(hwnd)
   ********************
      // Provided by Romain Strieff
      if type("SendMessage") # "FP"
         extern CLONG SendMessage(CHANDLE, CUINT, CLONG, CLONG) User32 From "SendMessageA"
      endif

      #ifndef WM_SYSCOMMAND
         #define WM_SYSCOMMAND 0x0112
      #endif
      #ifndef SC_RESTORE
         #define SC_RESTORE 0xF120
      #endif

      SendMessage(hwnd, WM_SYSCOMMAND, SC_RESTORE, 0)
      return

endclass
